.NH "Xware 3: Graphics"
.PP
Congratulations on purchasing Xware 3: the graphics package for \*(CO.
.PP
This package also holds the library
.BR libXpm.a ,
whose functions manipulate pix-mapped images;
a manual page for every program;
and a selection of GIF images for your enjoyment.
.SH "What is Xware?"
Xware is a series of packages from Mark Williams Company
that bundle some of the most popular and useful software
for the X Window System.
Each program in a Xware package comes with an executable binary;
source code;
instructions and scripts to help you recompile and install the program;
and a manual page for the program edited and formatted in the \*(CO
Lexicon format, which you can view with the \*(CO command
.BR man .
.PP
Other Xware packages are available or are being prepared.
These include packages of X window managers, games,
tools and utilities, and development tools.
Xware makes it easy and convenient for you
to enlarge your supply of X software.
.SH "System Resources"
.PP
All of the programs in this package run in eight megabytes of RAM.
.PP
The amount of disk space depends upon how many programs you install,
and whether you leave the sources archived on your system or delete them.
As a rule of thumb,
you should assume that each de-archived program and its sources
consume between one-half and one megabyte of disk space.
The exception is the set of screen-saver programs, which are
described below; each of these requires approximately 500 kilobytes of
disk space.
Directions on how to install a program are given below.
.PP
The size of the screen required varies from program to program.
A few will run on 640\(mu480 screen; most fit into 800\(mu600;
a few require a 1024\(mu768 screen.
Those that use the 1024\(mu768 screen can, in most instances,
be run under 800\(mu600, although the image being displayed may be cropped.
.PP
Most programs recompile correctly with the \*(CO C compiler.
A few must be recompiled with the GCC compiler, which is
not included with this package.
Each archive contains a file named
.BR README.Coh ,
which describes how to install and recompile it.
.SH "Contents of This Package"
.PP
The individual programs are kept in the form of compressed archives.
When you install Xware onto your system, all of the archives are
copied into directory
.BR /usr/X11/graphics .
The GIF images that are also included are installed into directory
.BR /usr/X11/gif ,
and the manual pages are installed into directory
.BR /usr/man/Xware3 .
.PP
The following describes the contents of this package:
.IP "\fB30dora.gif\fR"
.IS "\fB30dorac.gif\fR"
.IS "\fBapollo.gif\fR"
.IS "\fBapollo10.gif\fR"
.IS "\fBapollo9.gif\fR"
.IS "\fBapolloe2.gif\fR"
.IS "\fBfoc.gif\fR"
.IS "\fBm100.gif\fR"
.IS "\fBm100comp.gif\fR"
.IS "\fBm100gn.gif\fR"
.IS "\fBnovacygb.gif\fR"
.IS "\fBnovacygc.gif\fR"
These files contain some striking space images.
Those with the prefix ``apollo'' were taken from Project Apollo.
File
.B apolloe2.gif
contains a strikingly beautiful view of the Earth photographed about
halfway between the Earth and the Moon.
The other images were downloaded from the newly repaired
Hubble Space Telescope, and show the amazing detail that that instrument
can now achieve.
You can display these files with the program
.BR xv ,
described below.
.IP "\fBmpeg_play\fR"
Play MPEG video files.
Unlike other animation formats, which display a series of
bit-mapped image, MPEG files consist of instructions for computing the
images being shown.
.IP "\fBplanetge\fR"
This package consists of three programs, with which you can model
the geology and climate of an imaginary planet.
.IP
The first program,
.BR tec ,
models the plate tectonics of your imaginary planet, using a description
file that you prepare, then animates the movement of the continents
over the aeons.
It also draws maps that can be used by the other two programs.
.IP
The second program,
.BR clim ,
takes a map drawn by
.B tec
and models the climate for that planet.
Again, you can write a description that sets climatary parameters for
the planet, e.g., the planet's degree of inclination from the
plane of the ecliptic.
.IP
Finally, the program
.B planet
takes a two-dimensional map generated by
.BR tec
wraps it around a sphere, then rotates it for you.
.IP "\fBspaceout\fR"
Watch the stars fly past you, just as they did at the beginning of the
old ``Star Trek'' television program.
.IP "\fBxanim\fR"
Run
.B .anim
files that have been generated on an Amiga.
Included is a sample animation that does something interesting.
.IP "\fBxdali\fR"
Create a digital clock.
Unlike
.BR xclock ,
however, the letters of this clock ``melt'' into each other,
in a manner reminiscent of Salvadore Dali's melting watches.
.\".IP "\fBxgrasp\fR"
.\"Run GRASP (\fB.gl\fR)
.\"files generated under MS-DOS.
.\"The animation and color reproduction is quite good.
.IP "\fBxmandel\fR"
Explore the Mandelbrot set interactively.
This program will also save Mandelbrot images in GIF format, so you can
redisplay them later with the program
.BR xv .
.IP "\fBxphoon\fR"
Draw the current phase of the Moon on your system's root window.
It's an old favorite on Sun workstations.
.IP "\fBxpm\fR"
This archive contains the archive
.B libXpm.a
plus its source code.
This archive
also contains the command
.BR sxpm ,
which demonstrates how to use and display an XPM.
.IP
When you install this package onto your system,
the compiled archive
.B libXpm.a
is automatically copied into directory
.BR /usr/X11/lib .
.IP "\fBxscreen\fR"
This is a package of screensaver programs.
It consists of a utility that can install a graphics programs as a
screen-saver; plus a number of graphics programs.
Note that because this package is so large, only unlinked objects are
included \(em not source code or (in most instances) linked executables.
The file
.B README.Coh
describes how to re-link the programs and install them.
The package consists of the following programs:
.RS
.IP \fBxscreensaver\fR
Display graphics programs as screen-savers.
By modifying its resource file, you can tell this program to display one
graphics program as a screen-saver, or cycle among a number of programs.
.IP \fBxscreensaver-c\fR
Send instructions to
.B xscreensaver
even while it is running.
.IP \fBattraction\fR
Model the dance of nuclear particles, which attract or repel
each other depending upon how close they are to one another.
.IP \fBblitspin\fR
Rotate a bit-mapped image in an interesting way.
.IP \fBdecayscreen\fR
Take a snapshot of the root window, then slowly modify the image so that the
screen appears to be melting.
.IP \fBgreynetic\fR
Randomly draw stippled or colored rectangles.
.IP \fBhalo\fR
Randomly draw stippled or colored circles.
.IP \fBhelix\fR
Draw helical string-art patterns.
.IP \fBhopalong\fR
Draw real-plane fractals.
.IP \fBhypercube\fR
Animate a two-dimensional projection of a four-dimensional object.
.IP \fBimsmap\fR
Generate fractal maps.
.IP \fBnoseguy\fR
Animate a little man, who wanders around the screen and recites fortunes.
.IP \fBpyro\fR
Simulate fireworks exploding on the screen.
.IP \fBrocks\fR
Animate a flight through the asteroid belt.
Excellent animation!
.IP \fBqix\fR
Bounce colored lines around a window.
.IP \fBrorschach\fR
Generate Rorschach blots.
(Interpretation is entirely up to you.)
.IP \fBslidescreen\fR
Divide the screen into squares, then slide the squares around.
It resembles the game
.BR puzzle ,
except that it creates disorder out of order rather than the other way around.
.IP \fBxroger\fR
Display a variorum (and, some claim, more accurate) version of the X logo.
.RE
.IP "\fBxswarm\fR"
This program animates a swarm of ``bees'' that endlessly chase a ``wasp''
around its window.
Its many features let you do interesting things with the root window.
.IP "\fBxv\fR"
Display and modify a great variety of images, including the GIF images
included with this package.
This is the standard X program for displaying pictures.
.SH "Installing This Package"
.PP
To install this package onto your system, log in as the superuser
.B root
and type the installation command:
either
.DM
	/etc/install Xware3 /dev/fva0 4
.DE
if you have a 3.5-inch floppy-disk drive, or
.DM
	/etc/install Xware3 /dev/fha0 5
.DE
if your floppy-disk drive is 5.25 inches.
.B install
copies the programs into directory
.BR /usr/X11/graphics ,
installs the few extra tools you need to recompile these programs,
copies the GIF files into directory
.BR /usr/X11/gif ,
and automatically installs the manual pages for the programs.
.SH "Installing an Individual Program"
.PP
As described above, each program is kept in a compressed archive in directory
.BR /usr/X11/graphics .
Each archive contains a compiled version of the program, ready for running;
the sources for the program;
a file called
.BR README.Coh ,
which describes how to recompile the program, should you wish; and a script
named
.BR Install.Coh ,
which installs the program for you.
To install a program so you can use it, do the following:
.IP \(bu 0.3i
.B cd
to directory
.BR /usr/X11/graphics .
.IP \(bu
Use the command
.B gtar
to de-archive and uncompress the archive that holds the program you want.
For example, if you want to install program
.BR xanim ,
type the command:
.DM
	gtar -xvzf xanim.gtz
.DE
.IP \(bu
Change to the directory that holds the newly de-archived program.
For example, when you un-tar archive
.BR xanim.gtz ,
the program and its source files are copied into directory
.BR xanim .
.IP \(bu
Use the command
.B su
to become the superuser
.BR root ,
and execute script
.BR Install.Coh .
Each program has such a script, and it handles all the details of
installation for you.
.IP \(bu
After you have installed the program, you may wish to remove the source
code and other files that you do not need.
To do so,
.B cd
back to the program's parent directory, and use the command
.B "rm \-rf"
to remove the directory and its contents.
For example, after you have installed
.BR xanim ,
you can remove this directory by typing the following commands:
.DM
	cd ..
	rm -rf xanim
.DE
Note that the archive from which you copied the program,
.BR xanim.gtz ,
is untouched by removing the directory
.BR xanim .
You can always de-archive the program again should you wish to work with
its program files or re-install it.
.PP
If you wish to recompile a program, follow the directions given in file
.B README.Coh
in that program's source directory.
.SH "Copyrights"
.PP
Please note that the software in this package comes from third-party sources.
It is offered ``as is'', with no guarantee or warranty stated or implied,
whatsoever.
The copyrights on the source code and any executables built from it
belong to the persons who wrote the original code; full copyright
statements are included with the source code to each program.
We ask that you read and respect these statements.
.SH "Technical Support"
.PP
The sources in this package have been compiled and run successfully under
\*(CO.
If you have a problem bringing up one of the programs or with
compiling the source code as it is configured in this package, our
technical support team will attempt to help you.
However, because of the highly technical nature of the source
code in these packages, Mark Williams Company
.I cannot
give you technical assistance should you modify any of the source code
included in this package in any manner whatsoever.
.SH "A Final Word"
.PP
Most of the source code for these programs, and for the program shipped in
our other Xware packages,
is available for free on the Mark Williams bulletin board system.
The tutorial for
.B UUCP
in the \*(CO manual describes how to contact the BBS and make its services
available to you.
.PP
We hope that you enjoy using these graphical programs!
