MAIN

create database mwc

create table payment 
    (
     pay_no serial not null,
     pay_date date,
     invoice_no integer,
     amount money(8,2),
     com1 char(50)
    );

create table auth 
    (
     auth_no serial not null,
     auth_date date,
     return_date date,
     invoice_no integer,
     contact char(38),
     reason smallint,
     other_reason char(38),
     prod_no smallint
    );

create table inv_line 
    (
     invoice_no integer,
     prod_no smallint,
     quantity smallint,
     pack_no smallint
    );

create table terms 
    (
     term_no serial not null,
     term_name char(6)
    );

create table shippers 
    (
     ship_no serial not null,
     ship_name char(15),
     cust_cost money(6,2)
    );

create table ground 
    (
     from_zip smallint,
     to_zip smallint,
     zone smallint
    );

create table shipreg 
    (
     cust_no integer,
     ser_no integer,
     trace_no char(18)
    );

create table bad_disk 
    (
     baddisk_no serial not null,
     ser_no integer,
     cust_no integer,
     call_d date,
     med_type char(1),
     cmnt char(28),
     reply date,
     ship_no smallint,
     prod_no smallint,
     disk char(13),
     head smallint,
     cylinder smallint,
     badfile char(24),
     controller char(38),
     i_msgs char(38)
    );

create table call_tag 
    (
     tag_no integer,
     invoice_no integer,
     why char(70),
     action char(70),
     issue_date date,
     rec_date date
    );

create table w_z_p 
    (
     weight smallint,
     zone smallint,
     price money(5,2),
     commer smallint
    );

create table address 
    (
     cust_no integer,
     add_type char(1),
     line1 char(38),
     line2 char(38),
     line3 char(38),
     city char(20),
     state char(4),
     country char(14),
     zipcode char(11)
    );


create table regcard 
    (
     ser_no integer,
     cust_no integer,
     reg_date date,
     comp_type char(38),
     disk_size smallint,
     byte_m char(1),
     c_gazette char(1),
     cug char(1),
     circ_cel char(1),
     comm_acm char(1),
     comp_shop char(1),
     comp_lang char(1),
     comp_world char(1),
     dr_dobbs char(1),
     unix_rev char(1),
     unix_today char(1),
     unix_world char(1),
     ee_times char(1),
     embed_sys char(1),
     ieee_spec char(1),
     info_world char(1),
     pc_comp char(1),
     personal_comp char(1),
     personal_wk char(1),
     prog_journal char(1),
     sys_integrat char(1),
     pc_mag char(1),
     pc_week char(1),
     pc_world char(1),
     exp_level char(1),
     personal_use char(1),
     business_use char(1),
     education char(1)
    );

create table magazines 
    (
     inq_src serial not null,
     mag_name char(20),
     cost money(8,2),
     cur_ad smallint
    );


create table product 
    (
     prod_no serial not null,
     prod_name char(30),
     comment1 char(30),
     price money(8,2),
     weight decimal(6,2),
     nolist smallint,
     b_flag smallint
    );

create table batch 
    (
     batch_ix serial not null,
     batch_no smallint,
     batch_date date
    );

create table cmemo 
    (
     memo_no serial not null,
     memo_date date,
     invoice_no integer,
     auth_no integer,
     amount money(8,2),
     com1 char(50),
     com2 char(50),
     batch_ix smallint,
     ref_no integer,
     cap_no integer,
     tym_flag smallint
    );

create table sws 
    (
     systm char(20)
    );

create table freight 
    (
     prod_no smallint,
     ship_no smallint,
     dest_no smallint,
     const_cost money(6,2),
     lb_cost money(6,2)
    );

create table dests 
    (
     dest_no serial not null,
     dest_name char(15)
    );

create table states 
    (
     state char(4),
     country char(14),
     blue_zone smallint,
     red_zone smallint,
     dest_no smallint
    );

create table invoice 
    (
     invoice_no serial not null,
     cust_no integer,
     invoice_date date,
     icomments char(50),
     inq_src smallint,
     subtotal money(8,2),
     ship_no smallint,
     card_no decimal(17,0),
     exp_date char(5),
     ship_amt money(6,2),
     discount money(8,2),
     taxes money(8,2),
     itotal money(8,2),
     ship_date date,
     term_no smallint,
     user_id char(9),
     bounce char(1),
     batch_ix smallint,
     ref_no integer,
     cap_no integer,
     tym_flag smallint,
     back_flag smallint,
     frozen char(1)
    );

create table newreg 
    (
     ser_no integer,
     cust_no integer,
     reg_date date,
     comp_type char(38),
     disk_size smallint,
     develop char(1),
     learn char(1),
     other char(1),
     communication char(1),
     business char(1),
     software_exp smallint,
     exp_level char(1),
     personal_use char(1),
     business_use char(1),
     education char(1),
     c_comp char(1),
     turbo_c char(1),
     microsoft_c char(1),
     other_c char(1),
     macintosh char(1),
     windows char(1),
     workstations char(1),
     sun char(1),
     ibm char(1),
     dec_sys char(1),
     hewlett_packard char(1),
     operating_sys char(1),
     unix_v char(1),
     ultrix char(1),
     xenix char(1),
     aix char(1),
     sunos char(1),
     hpux char(1),
     esix char(1),
     other_os char(10)
    );

create table customer 
    (
     cust_no serial not null,
     contact char(38),
     phone_no char(36),
     all_nfo char(1),
     user_id char(9),
     cust_date date,
     crunch char(10),
     inq_src smallint
    );

create table pickup_line 
    (
     invoice_no integer,
     contact char(14),
     address char(18),
     city char(8),
     state char(3),
     country char(4),
     zipcode char(7),
     commer smallint,
     weight smallint,
     zone smallint,
     charge money(8,2),
     dec_value money(8,2),
     cod_amt money(8,2),
     cod_chrg money(8,2),
     aod char(1),
     cll char(1),
     pack_no smallint,
     closed char(1),
     cl_date date,
     ship_loc smallint
    );

create table marked 
    (
     invoice_no integer
    );

create table recnumber 
    (
     rec_number integer
    );




create table workf 
    (
     cust_no integer,
     tbl smallint,
     addons smallint
    );

create table workfb 
    (
     cust_no integer,
     tbl smallint,
     addons smallint
    );

END MAIN
